/** @file nanoparticleBuilderCmd.hpp
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef NANOPARTICLEBUILDERCMD_H
#define NANOPARTICLEBUILDERCMD_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define CMDLINE_PARSER_PACKAGE "nanoparticleBuilder"
#endif

#ifndef CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define CMDLINE_PARSER_PACKAGE_NAME "nanoparticleBuilder"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION ""
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * output_arg;	/**< @brief Output file name.  */
  char * output_orig;	/**< @brief Output file name original value given at command line.  */
  const char *output_help; /**< @brief Output file name help description.  */
  double latticeConstant_arg;	/**< @brief Lattice spacing in Angstroms for cubic lattice..  */
  char * latticeConstant_orig;	/**< @brief Lattice spacing in Angstroms for cubic lattice. original value given at command line.  */
  const char *latticeConstant_help; /**< @brief Lattice spacing in Angstroms for cubic lattice. help description.  */
  double radius_arg;	/**< @brief Nanoparticle radius in Angstroms.  */
  char * radius_orig;	/**< @brief Nanoparticle radius in Angstroms original value given at command line.  */
  const char *radius_help; /**< @brief Nanoparticle radius in Angstroms help description.  */
  double* shellRadius_arg;	/**< @brief Radius containing within it only molecules of a specific component. Specified for each component > 1 in the template file..  */
  char ** shellRadius_orig;	/**< @brief Radius containing within it only molecules of a specific component. Specified for each component > 1 in the template file. original value given at command line.  */
  unsigned int shellRadius_min; /**< @brief Radius containing within it only molecules of a specific component. Specified for each component > 1 in the template file.'s minimum occurreces */
  unsigned int shellRadius_max; /**< @brief Radius containing within it only molecules of a specific component. Specified for each component > 1 in the template file.'s maximum occurreces */
  const char *shellRadius_help; /**< @brief Radius containing within it only molecules of a specific component. Specified for each component > 1 in the template file. help description.  */
  double* molFraction_arg;	/**< @brief Builds a multi-component random alloy nanoparticle. A mole Fraction must be specified for each component > 1 in the template file..  */
  char ** molFraction_orig;	/**< @brief Builds a multi-component random alloy nanoparticle. A mole Fraction must be specified for each component > 1 in the template file. original value given at command line.  */
  unsigned int molFraction_min; /**< @brief Builds a multi-component random alloy nanoparticle. A mole Fraction must be specified for each component > 1 in the template file.'s minimum occurreces */
  unsigned int molFraction_max; /**< @brief Builds a multi-component random alloy nanoparticle. A mole Fraction must be specified for each component > 1 in the template file.'s maximum occurreces */
  const char *molFraction_help; /**< @brief Builds a multi-component random alloy nanoparticle. A mole Fraction must be specified for each component > 1 in the template file. help description.  */
  double vacancyPercent_arg;	/**< @brief Percentage of atoms to remove from within vacancy range.  */
  char * vacancyPercent_orig;	/**< @brief Percentage of atoms to remove from within vacancy range original value given at command line.  */
  const char *vacancyPercent_help; /**< @brief Percentage of atoms to remove from within vacancy range help description.  */
  double vacancyInnerRadius_arg;	/**< @brief Radius arround core-shell where vacancies should be located..  */
  char * vacancyInnerRadius_orig;	/**< @brief Radius arround core-shell where vacancies should be located. original value given at command line.  */
  const char *vacancyInnerRadius_help; /**< @brief Radius arround core-shell where vacancies should be located. help description.  */
  double vacancyOuterRadius_arg;	/**< @brief Radius arround core-shell where vacancies should be located..  */
  char * vacancyOuterRadius_orig;	/**< @brief Radius arround core-shell where vacancies should be located. original value given at command line.  */
  const char *vacancyOuterRadius_help; /**< @brief Radius arround core-shell where vacancies should be located. help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int latticeConstant_given ;	/**< @brief Whether latticeConstant was given.  */
  unsigned int radius_given ;	/**< @brief Whether radius was given.  */
  unsigned int shellRadius_given ;	/**< @brief Whether shellRadius was given.  */
  unsigned int molFraction_given ;	/**< @brief Whether molFraction was given.  */
  unsigned int vacancyPercent_given ;	/**< @brief Whether vacancyPercent was given.  */
  unsigned int vacancyInnerRadius_given ;	/**< @brief Whether vacancyInnerRadius was given.  */
  unsigned int vacancyOuterRadius_given ;	/**< @brief Whether vacancyOuterRadius was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_config_file() instead
 */
int cmdline_parser_configfile (const char *filename,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_config_file (const char *filename,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* NANOPARTICLEBUILDERCMD_H */
